<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Pseudocode</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">

	<link rel="stylesheet" href="css/theme/black.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<!-- UGLY inline CSS but using this div to test Unclassified banner -->
	<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
	<div class="reveal">
		<div class="slides">
			<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">
				<section>
					<h1>Intro to Pseudocode</h1>
				</section>

				<section >
				<h2>Overview</h2>
				<ul>
					<li>What is pseudocode?</li>
					<li>Why would we use pseudocode?</li>
					<li>How to create pseudocode</li>
				</ul>
				<aside class="notes">
					Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
					instructor view!!
				</aside>
                </section>
                
                <section>
                    <h2>Course Objectives</h2>
                </section>
            </section>
            <section>
                <section>
                    <h2>Why pseudocode?</h2>

                    <ul>
                        <li>Weeks of programming save hours of planning</li>
                        <li>The absence of a plan is a plan to fail</li>
                        <li>If you don't know where you're going how will you get there?</li>

                    </ul>
                </section>

                <section>
                    <h2>Why pseudocode?</h2>

                    <ul>
                        <h3><b>Planning - </b></h3>
                        <li>improves program efficiency</li>
                        <li>improves program design</li>
                        <li>can fix problems before they arise</li>
                        <li>helps you from getting lost in the weeds</li>

                    </ul>
                </section>

                <section>
                    <h2>What is pseudocode?</h2>

                    <ul>
                        <li>plain text description of an algorithm / program</li>
                        <li>a flow chart that illustrates an algorithm / program </li>


                    </ul>
                </section>
            </section>
            <section>
                <section>
                    <h2>Writing Pseudocode</h2>
                    <table style='font-size:80%'>
                        <tr>
                            <td>Type</td>
                            <td>Example</td>
                        </tr>
                        <tr>
                            <td>start/stop</td>
                            <td>programs begin with start, end with stop<br>start and stop are aligned </td>
                        </tr>
                        <tr>
                            <td>statements - basic commands </td>
                            <td>
                                <ul>
                                    <li> initialize variable</li>
                                    <li> increment value</li>
                                    <li> print value</li>
                                </ul>
                            </td>
                        </tr>
                        <tr>
                            <td> (mathematical) operations</td>
                            <td> addition, subtraction, comparison, variable assignment</td>
                        </tr>
                    </table>
                </section>
                <section>
                    <table style='font-size:80%'>
                        <tr>
                            <td>Keywords</td>
                            <td> written in all caps - reserved by language. E.g. GET, SET, PRINT, RETURN </td>
                        </tr>
                        <tr>
                            <td>Type</td>
                            <td>Example</td>
                        </tr>
                        <tr>
                            <td>Control flow </td>
                            <td>
                                <ul>
                                    <li> IF ELSE</li>
                                    <li> WHILE </li>
                                    <li> CASE* </li>
                                    <li> FOR / FOR EACH</li>
                                </ul>
                            </td>
                        </tr>
                        <tr>
                            <td> Functions </td>
                            <td> little 'sub' programs / methods </td>
                        </tr>
                        <tr>
                            <td>Exception handling </td>
                            <td>EXCEPTION: what happens when something is wrong / breaks / is not planned for </td>
                        </tr>
                    </table>
                </section>
            </section>
            <section>
                <section>
                    <h2>Pseudocode Flowchart</h2>
                    <h4>Parts of a flowchart:</h4>
					<ul>
						<li>start/stop</li>
						<li>decisions</li>
						<li>input/output</li>
						<li>actions</li>
					</ul>
                </section>
                <section>
                    <table>
						<tr>
							<td>Purpose</td>
							<td>Symbol</td>
						</tr>
						<tr>
							<td>start/stop </td>
                            <td> lozenge</td>
                            <td><img src="assets/StartStop4a.png" alt=""></td>
						</tr>
						<tr>
							<td>processing/actions</td>
                            <td>rectangle</td>
                            <td><img src="assets/mynumb2.jpg" alt=""></td>
						</tr>
					</table>
                </section>
                <section>
                    <table>
                        <tr>
							<td>Purpose</td>
							<td>Symbol</td>
						</tr>
                        <tr>
							<td> input/output</td>
                            <td> parallelogram</td>
                            <td><img src="assets/input1.jpg" alt=""></td>
						</tr>
						<tr>
							<td> decisions (or tests)</td>
							<td> diamond</td>
						</tr>
                    </table>
				</section>
				<section>
					<h3>Flowchart Example:</h3>
					<img src="assets/flowchart1.jpg" alt="">
				</section>
                <section>
					<h3>Parts of a flowchart</h3>
					<p style='font-size:30%'>Image from <a href="https://xkcd.com/518/">xkcd</a></p>
					<img height=500; src="../assets/xkcd_flow_charts.png">

				</section>

				<section>
					<h3>Flowchart actions</h3>
					<img height=500 src="../assets/flowchart_actions.png">
				</section>

				<section>
					<h3>Flowchart decisions</h3>
					<img src="../assets/flowchart_decisions.png">
				</section>
			</section>
			<section>
				<section>
					<h2>
						Labs
					</h2>
				</section>
			</section>
			<section>
				<section>
					<h2>Overview</h2>
					<ul>
						<li>What is Pseudocode?</li>
						<li>Why do we use Pseudocode?</li>
						<li>Parts of Flowchart:
							<ul>
								<li>start/stop</li>
								<li>decisions</li>
								<li>input/output</li>
								<li>actions</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<h2>Questions?</h2>
				</section>
			</section>
        </div>
	</div>
	<!-- This footer doesn't work. Need to play with CSS -->
	<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->

	<!-- DO NOT TOUCH -->
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>